# Contributing

If you'd like to help out, thanks! We use Visual Studio 2022 for development, though any standard .NET 5 development environment should work. Please read through these guidelines to get started:

- Read through the ARCHITECTURE.md file to understand how csharprepl works. Depending on what you want to do, changes to the underlying PrettyPrompt library may be required.
- For new features, please open an issue first to discuss and design the feature. This will help reduce the chance of conflicting designs.
- Please include an xunit test, and ensure any code warnings and nullability issues are resolved.

Thanks!

## CSharpRepl Contributors

Thanks to everyone who contributes! The following contributors have helped out with CSharpRepl:

- Hubert Kindermann ([kindermannhubert](https://github.com/kindermannhubert))
- [IBIT-ZEE](https://github.com/IBIT-ZEE)
- Nattapong Nunpan ([aixasz](https://github.com/aixasz))
- Ivan Kara ([realivanjx](https://github.com/realivanjx))
- José Javier Rodríguez Zas (JJ) ([jjavierdguezas](https://github.com/jjavierdguezas))
- Marlon Regenhardt ([Regenhardt](https://github.com/Regenhardt))
- Luiz-Ossinho ([Luiz-Ossinho](https://github.com/Luiz-Ossinho))
- Vinod Pal ([VNDPAL](https://github.com/VNDPAL))
- Rasim Keita ([Keyros](https://github.com/Keyros))
- Atif Aziz ([atifaziz](https://github.com/atifaziz))
- [lonix1](https://github.com/lonix1)
- Weihan Li ([WeihanLi](https://github.com/WeihanLi))

## PrettyPrompt Contributors

CSharpRepl heavily relies on the PrettyPrompt library, so make sure to check out the [contributors](https://github.com/waf/PrettyPrompt/blob/main/CONTRIBUTORS.md) there, too!
